#ifndef SCANNERSEWPO_H
#define SCANNERSEWPO_H

#include <cmath>
#include "ScannerSModelclasses.h"
#include "ScannerSAux.h"

static const double Mz=91.2;
static const double Mw=80.3;
static const double Mz2=91.2*91.2;
static const double Mw2=80.3*80.3;
static const double cw2=Mw2/Mz2;
static const double sw2=1-cw2;
static const double Pi=acos(-1);

// SM functions
double DSsm(double Mass);
double DTsm(double Mass);
double DUsm(double Mass);
double DVsm(double Mass);
double DWsm(double Mass);
double DXsm(double Mass);

double Psi(double A);
double PsiIntegrand(double x,void * params);
double Chi(double A);
double ChiIntegrand(double x,void * params);

// N-singlets functions
double DS_nsinglets(MassRef & Mass, MmixingRef & Mixing,size_t ih);
double DT_nsinglets(MassRef & Mass, MmixingRef & Mixing,size_t ih);
double DU_nsinglets(MassRef & Mass, MmixingRef & Mixing,size_t ih);
double DV_nsinglets(MassRef & Mass, MmixingRef & Mixing,size_t ih);
double DX_nsinglets(MassRef & Mass, MmixingRef & Mixing,size_t ih);
double DW_nsinglets(MassRef & Mass, MmixingRef & Mixing,size_t ih);

//2HDM functions
double F0(double A, double B);
double F1(double A, double B);
double IntegrandF1(double x,void * params);
double G1(double A, double B);
double IntegrandG1(double x,void * params);
double G2func(double A);
double IntegrandG2func(double x,void * params);

double DS_2HDM(double mlight, double mHheavy, double mA, double mcharged,double alpha, double beta);
double DT_2HDM(double mlight, double mHheavy, double mA, double mcharged,double alpha, double beta);
double DU_2HDM(double mlight, double mHheavy, double mA, double mcharged,double alpha, double beta);
double DV_2HDM(double mlight, double mHheavy, double mA, double mcharged,double alpha, double beta);
double DW_2HDM(double mlight, double mHheavy, double mA, double mcharged,double alpha, double beta);
double DX_2HDM(double mlight, double mHheavy, double mA, double mcharged,double alpha, double beta);
bool CheckVirtual(double m1, double m2);


#endif
